=== debian/changelog ===
madness (0.10.1~gite4aa500e-10) unstable; urgency=medium

  * debian/patches/disable_pie.patch: New patch, disables PIE, taken from
    upstream commit f625ad51.
  * debian/rules (DEB_BUILD_MAINT_OPTIONS): Comment out variable again.

 -- Michael Banck <mbanck@debian.org>  Fri, 30 Dec 2016 18:02:11 +0100

madness (0.10.1~gite4aa500e-9) unstable; urgency=medium

  * debian/rules (override_dh_auto_test): Reenable tests on i386 again.
  * debian/rules (DEB_BUILD_MAINT_OPTIONS): Disable pie.

 -- Michael Banck <mbanck@debian.org>  Fri, 30 Dec 2016 01:16:31 +0100

madness (0.10.1~gite4aa500e-8) unstable; urgency=medium

  * debian/control (Build-Depends): Added libxc-dev.
  * debian/patches/cmake_mraplot_install.patch: New patch, excludes the mraplot
    utility from being exported as a CMake target.

 -- Michael Banck <mbanck@debian.org>  Thu, 29 Dec 2016 16:00:05 +0100

madness (0.10.1~gite4aa500e-7) unstable; urgency=medium

  * debian/libmadness-dev.install: No longer include the pkgconfig file, as it
    is not created/installed by the CMake build.
  * debian/patches/cmake_installdir.patch: New patch, installs the cmake module
    files under MADNESS_INSTALL_LIBDIR.
  * debian/changelog (Build-Depends): Add libtbb-dev.
  * debian/patches/relax_tbb_version_check.patch: New patch, relaxes the
    version requirement for TBB.

 -- Michael Banck <mbanck@debian.org>  Thu, 29 Dec 2016 10:31:54 +0100

madness (0.10.1~gite4aa500e-6) unstable; urgency=medium

  * debian/rules (override_dh_auto_configure): Set MADNESS_INSTALL_LIBDIR
    rather than CMAKE_INSTALL_LIBDIR.

 -- Michael Banck <mbanck@debian.org>  Wed, 28 Dec 2016 21:22:25 +0100

madness (0.10.1~gite4aa500e-5) unstable; urgency=medium

  * debian/rules (DEB_HOST_MULTIARCH): New variable.
  * debian/rules (override_dh_auto_configure): Set CMAKE_INSTALL_LIBDIR.

 -- Michael Banck <mbanck@debian.org>  Wed, 28 Dec 2016 18:58:14 +0100

madness (0.10.1~gite4aa500e-4) unstable; urgency=medium

  * debian/control (Build-Depends): Replaced autoconf, automake and
    autotools-dev with cmake and python.
  * debian/rules: Overhaul for CMake.
  * debian/rules: Removed parallel flag for dh.

 -- Michael Banck <mbanck@debian.org>  Wed, 28 Dec 2016 15:50:10 +0100

madness (0.10.1~gite4aa500e-3) unstable; urgency=medium

  * debian/rules (override_dh_auto_clean): Remove some more leftover files.
  * debian/control (Build-Depends): Added pkg-config.
  * debian/patches/revert-225c3977.patch: Removed, no longer needed.
  * debian/control (Build-Depends): Replaced mpi-default-dev and
    mpi-default-bin with libmpich-dev.
  * debian/rules: No longer include /usr/share/mpi-default-dev/debian_defaults.
  * debian/rules (override_dh_auto_configure): Pass MPI link libraries via LIBS
    variable.

 -- Michael Banck <mbanck@debian.org>  Tue, 27 Dec 2016 16:22:57 +0100

madness (0.10.1~gite4aa500e-2) unstable; urgency=medium

  * debian/patches/blaslapack_handle_empty_LIBS.patch: New patch, avoids
    leading whitespace in LIBS variabls, as cmake chokes on it when seeing it
    exported in madness-config.cmake.

 -- Michael Banck <mbanck@debian.org>  Mon, 26 Dec 2016 13:38:56 +0100

madness (0.10.1~gite4aa500e-1) unstable; urgency=medium

  * New upstream snapshot.
  * debian/patches/revert-225c3977.patch: New patch, reverts commit 225c3977,
    which causes trouble with autogen.sh.

 -- Michael Banck <mbanck@debian.org>  Thu, 22 Dec 2016 13:47:29 +0100
