=== debian/control ===
Source: madness
Section: libdevel
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>, Graham Inggs <ginggs@debian.org>
Build-Depends: cmake,
               debhelper (>= 9),
               libblas-dev,
               liblapack-dev,
               libmpich-dev,
               libtbb-dev,
               libxc-dev,
               pkg-config,
               python
Standards-Version: 3.9.8
Homepage: https://github.com/m-a-d-n-e-s-s/madness
Vcs-Browser: https://anonscm.debian.org/viewvc/debichem/unstable/madness/
Vcs-Svn: svn://anonscm.debian.org/debichem/unstable/madness/

Package: libmadness-dev
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Numerical Environment for Scientific Simulation (development files)
 MADNESS (Multiresolution Adaptive Numerical Environment for Scientific
 Simulation) provides a high-level environment for the solution of integral and
 differential equations in many dimensions using adaptive, fast methods with
 guaranteed precision based on multi-resolution analysis and novel separated
 representations. There are three main components to MADNESS. At the lowest
 level is a new petascale parallel programming environment that increases
 programmer productivity and code performance/scalability while maintaining
 backward compatibility with current programming tools such as MPI and Global
 Arrays. The numerical capabilities built upon the parallel tools provide a
 high-level environment for composing and solving numerical problems in many
 (1-6+) dimensions. Finally, built upon the numerical tools are new
 applications with initial focus upon chemistry, atomic and molecular physics,
 material science, and nuclear structure.
 .
 This package contains the static libraries and the header files.
