=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --buildsystem cmake

override_dh_auto_clean:
	-dh_auto_clean
	rm -f config/missing config/config.sub config/depcomp config/config.guess config/test-driver config/compile config/install-sh config/lt* config/libtool.m4
	rm -f aclocal.m4 configure doc/doxygen.cfg src/madness/config.h.in
	rm -f src/madness/mra/fplot.dat src/madness/mra/opf.dat src/madness/mra/opfplot.dat src/madness/mra/testline1  src/madness/mra/testline2 src/madness/mra/testline3 src/madness/mra/testplot src/madness/world/test.dat src/madness/world/testme.ar
	rm -f doc/Makefile src/apps/exciting/Makefile src/apps/hf/Makefile src/apps/interior_bc/Makefile src/apps/nick/Makefile src/apps/polar/Makefile
	rm -f src/examples/compiler/Makefile-prog src/examples/compiler/Makefile-prog.in src/madness/world/log.00000
	find . -name "Makefile.in" | xargs rm -f

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_SHARED_LIBS=OFF -DMADNESS_INSTALL_LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_auto_install:
	dh_auto_install --destdir=$(CURDIR)/debian/tmp

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifeq (,$(filter $(DEB_HOST_ARCH),armel))
	-dh_auto_test || cat src/madness/world/test-suite.log
endif
endif
