=== debian/watch ===
version=3
https://github.com/m-a-d-n-e-s-s/madness/releases .*/madness-([\d.]+)\.tar\.gz$
