=== debian/watch ===
version=3
https://github.com/m-a-d-n-e-s-s/madness/tags .*/v?([\d.]+)\.tar\.gz$
